SystemOrganization addCategory: #'SMock-SUnit'!

TestCase subclass: #SMockSUnitTestCase
	instanceVariableNames: 'trackedMocks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SMock-SUnit'!

!SMockSUnitTestCase commentStamp: 'guest 7/17/2010 12:22' prior: 0!
The following comment was copied from the original comments of SMock.SMockTestCase

==========================================================

SMockTestCase is the main integration point for sMock mock objects into the SUnitToo unit test framework.  In order to have SMockTestCase automatically verify that all expectations have been met for a Mock, create the Mock with #mock.

Instance Variables:
	trackedMocks	<(Collection of: Mock)>	Collection of all mocks created with the #mock: method.

!

!SMockSUnitTestCase methodsFor: 'mocks' stamp: 'guest 7/17/2010 12:22'!
mock: aClass
	"Create a new mock object for the specified class and add it to this test's collection of tracked mock objects.

	Example:

	| mock |
	mock := self mock: OrderedCollection.
	(mock stub: #add) will: [ do something here ].
"

	^ trackedMocks add: (Mock newForClass: aClass withException: TestFailure).! !

!SMockSUnitTestCase methodsFor: 'mocks' stamp: 'guest 7/17/2010 12:22'!
newMock
	"Create a new mock object and add it to this test's collection of tracked mock objects.

	Example:

	| mock |
	mock := self newMock.
	(mock stub: #add) will: [ do something here ].
"

	^ trackedMocks add: (Mock newWithException: TestFailure).! !

!SMockSUnitTestCase methodsFor: 'running' stamp: 'guest 7/17/2010 12:22'!
setUp
	"Set up the tracked mock objects for the running test.  If SMockTestCase subclasses implement setUp, ensure that the method calls SMockTestCase>>setUp.

	Example:
	SomeClassTest>>setUp
		super setUp.
		<other setup stuff>
"

	super setUp.

	trackedMocks := OrderedCollection new.! !

!SMockSUnitTestCase methodsFor: 'running' stamp: 'guest 7/17/2010 12:22'!
tearDown
	"Verify that any tracked Mocks have all expectations met.  Ensure that any subclasses of SMockTestCase which implement #tearDown call SMockTestCase>>tearDown.

	Example:
	SomeClassTest>>tearDown
		super tearDown.
		<other tearDown functionality>
"

	trackedMocks do: [ :mock |
		[ mock verify ] on: VerificationException do: [ :ex | self signalFailure: ex messageText ] ]! !
